Index: Makefile
===================================================================
--- Makefile	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ Makefile	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -54,5 +54,5 @@
 
 cscope:
-	find abi kernel boot uspace -regex '^.*\.[chsS]$$' | xargs $(CSCOPE) -b -k -u -f$(CSCOPE).out
+	find kernel boot uspace -regex '^.*\.[chsS]$$' | xargs $(CSCOPE) -b -k -u -f$(CSCOPE).out
 
 # Pre-integration build check
Index: abi/include/ipc/event.h
===================================================================
--- abi/include/ipc/event.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ abi/include/ipc/event.h	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -36,5 +36,4 @@
 #define ABI_IPC_EVENT_H_
 
-/** Global events */
 typedef enum event_type {
 	/** New data available in kernel log */
@@ -47,10 +46,4 @@
 } event_type_t;
 
-/** Per-task events. */
-typedef enum event_task_type {
-	EVENT_TASK_STATE_CHANGE = EVENT_END,
-	EVENT_TASK_END
-} event_task_type_t;
-
 #endif
 
Index: abi/include/ipc/methods.h
===================================================================
--- abi/include/ipc/methods.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ abi/include/ipc/methods.h	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -171,16 +171,4 @@
 #define IPC_M_DATA_READ  8
 
-/** Authorize change of recipient's state in a third party task.
- * - ARG1 - user protocol defined data
- * - ARG2 - user protocol defined data
- * - ARG3 - user protocol defined data
- * - ARG5 - sender's phone to the third party task
- *
- * on EOK answer, the recipient must set:
- *
- * - ARG1 - recipient's phone to the third party task
- */
-#define IPC_M_STATE_CHANGE_AUTHORIZE	9
-
 /** Debug the recipient.
  * - ARG1 - specifies the debug method (from udebug_method_t)
@@ -188,5 +176,5 @@
  *
  */
-#define IPC_M_DEBUG 10
+#define IPC_M_DEBUG  9
 
 /** Last system IPC method */
Index: boot/Makefile.common
===================================================================
--- boot/Makefile.common	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ boot/Makefile.common	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -143,5 +143,4 @@
 	$(USPACE_PATH)/app/blkdump/blkdump \
 	$(USPACE_PATH)/app/bnchmark/bnchmark \
-	$(USPACE_PATH)/app/devctl/devctl \
 	$(USPACE_PATH)/app/dltest/dltest \
 	$(USPACE_PATH)/app/dltest2/dltest2 \
Index: kernel/arch/ia32/Makefile.inc
===================================================================
--- kernel/arch/ia32/Makefile.inc	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ kernel/arch/ia32/Makefile.inc	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -64,8 +64,4 @@
 endif
 
-ifeq ($(PROCESSOR),i486)
-	CMN2 = -march=i486
-endif
-
 ifeq ($(PROCESSOR),core)
 	CMN2 = -march=prescott
Index: kernel/arch/ia32/include/asm.h
===================================================================
--- kernel/arch/ia32/include/asm.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ kernel/arch/ia32/include/asm.h	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -311,5 +311,4 @@
 }
 
-#ifndef PROCESSOR_i486
 /** Write to MSR */
 NO_TRACE static inline void write_msr(uint32_t msr, uint64_t value)
@@ -336,5 +335,4 @@
 	return ((uint64_t) dx << 32) | ax;
 }
-#endif
 
 
Index: kernel/arch/ia32/include/atomic.h
===================================================================
--- kernel/arch/ia32/include/atomic.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ kernel/arch/ia32/include/atomic.h	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -121,7 +121,5 @@
 	asm volatile (
 		"0:\n"
-#ifndef PROCESSOR_i486
 		"pause\n"        /* Pentium 4's HT love this instruction */
-#endif
 		"mov %[count], %[tmp]\n"
 		"testl %[tmp], %[tmp]\n"
Index: kernel/arch/ia32/include/cycle.h
===================================================================
--- kernel/arch/ia32/include/cycle.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ kernel/arch/ia32/include/cycle.h	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -40,7 +40,4 @@
 NO_TRACE static inline uint64_t get_cycle(void)
 {
-#ifdef PROCESSOR_i486
-	return 0;
-#else
 	uint64_t v;
 	
@@ -51,5 +48,4 @@
 	
 	return v;
-#endif
 }
 
Index: kernel/arch/ia32/src/asm.S
===================================================================
--- kernel/arch/ia32/src/asm.S	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ kernel/arch/ia32/src/asm.S	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -405,11 +405,5 @@
 	xorl %eax, %eax
 	cmpl $(GDT_SELECTOR(KTEXT_DES)), ISTATE_OFFSET_CS(%esp)
-#ifdef PROCESSOR_i486
-	jz 0f
-	movl %eax, %ebp
-0:
-#else
 	cmovnzl %eax, %ebp
-#endif
 
 	movl %ebp, ISTATE_OFFSET_EBP_FRAME(%esp)
Index: kernel/arch/ia32/src/boot/boot.S
===================================================================
--- kernel/arch/ia32/src/boot/boot.S	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ kernel/arch/ia32/src/boot/boot.S	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -97,4 +97,20 @@
 	pm_status $status_prot
 	
+	movl $(INTEL_CPUID_LEVEL), %eax
+	cpuid
+	cmp $0x0, %eax  /* any function > 0? */
+	jbe pse_unsupported
+	
+	movl $(INTEL_CPUID_STANDARD), %eax
+	cpuid
+	bt $(INTEL_PSE), %edx
+	jc pse_supported
+	
+	pse_unsupported:
+		
+		pm_error $err_pse
+	
+	pse_supported:
+	
 #include "vesa_prot.inc"
 	
@@ -124,71 +140,4 @@
 		jmp hlt0
 
-/** Calculate unmapped address of the end of the kernel. */
-calc_end_of_kernel:
-	movl $hardcoded_load_address, %edi
-	andl $0x7fffffff, %edi
-	movl (%edi), %esi
-	andl $0x7fffffff, %esi
-	
-	movl $hardcoded_ktext_size, %edi
-	andl $0x7fffffff, %edi
-	addl (%edi), %esi
-	andl $0x7fffffff, %esi
-	
-	movl $hardcoded_kdata_size, %edi
-	andl $0x7fffffff, %edi
-	addl (%edi), %esi
-	andl $0x7fffffff, %esi
-	movl %esi, end_of_kernel
-	ret
-
-/** Find free 2M (+4k for alignment) region where to store page tables */
-find_mem_for_pt:
-	/* Check if multiboot info is present */
-	cmpl $0x2BADB002, grub_eax
-	je check_multiboot_map
-	ret
-check_multiboot_map:
-	/* Copy address of the multiboot info to ebx */
-	movl grub_ebx, %ebx
-	/* Check if memory map flag is present */
-	movl (%ebx), %edx
-	andl $(1 << 6), %edx
-	jnz use_multiboot_map
-	ret
-use_multiboot_map:
-	/* Copy address of the memory map to edx */
-	movl 48(%ebx), %edx
-	movl %edx, %ecx
-	addl 44(%ebx), %ecx
-	/* Find a free region at least 2M in size */
-	check_memmap_loop:
-		/* Is this a free region? */
-		cmp $1, 20(%edx)
-		jnz next_region
-		/* Check size */
-		cmp $0, 16(%edx)
-		jnz next_region
-		cmpl $(2 * 1024 * 1024 + 4 * 1024), 12(%edx)
-		jbe next_region
-		cmp $0, 8(%edx)
-		jz found_region
-	next_region:
-		cmp %ecx, %edx
-		jbe next_region_do
-		ret
-	next_region_do:
-		addl (%edx), %edx
-		addl $4, %edx
-		jmp check_memmap_loop
-	found_region:
-		/* Use end of the found region */
-		mov 4(%edx), %ecx
-		add 12(%edx), %ecx
-		sub $(2 * 1024 * 1024), %ecx
-		mov %ecx, free_area
-	ret
-		
-
 /** Setup mapping for the kernel.
  *
@@ -199,54 +148,16 @@
 .global map_kernel
 map_kernel:
-	/* Paging features */
 	movl %cr4, %ecx
+	orl $(1 << 4), %ecx      /* PSE on */
 	andl $(~(1 << 5)), %ecx  /* PAE off */
 	movl %ecx, %cr4
 	
-	call calc_end_of_kernel
-	call find_mem_for_pt
-	mov end_of_kernel, %esi
-	mov free_area, %ecx
-	cmpl %esi, %ecx
-	jbe use_end_of_kernel
-	mov %ecx, %esi
-	/* Align address down to 4k */
-	andl $(~4095), %esi
-use_end_of_kernel:
-	
-	/* Align address to 4k */
-	addl $4095, %esi
-	andl $(~4095), %esi
-	
-	/* Allocate space for page tables*/	
-	movl %esi, pt_loc
-	movl $ballocs, %edi
-	andl $0x7fffffff, %edi
-	movl %esi, (%edi)
-	addl $4, %edi
-	movl $(2*1024*1024), (%edi)
-	
-	/* Fill page tables */
-	xorl %ecx, %ecx
-	xorl %ebx, %ebx
-	
-	floop_pt:
-		movl $((1 << 1) | (1 << 0)), %eax
-		orl %ebx, %eax
-		movl %eax, (%esi, %ecx, 4)
-		addl $(4 * 1024), %ebx
-		
-		incl %ecx
-		cmpl $(512 * 1024), %ecx
-		jl floop_pt
-	
-	/* Fill page directory */
 	movl $(page_directory + 0), %esi
 	movl $(page_directory + 2048), %edi
 	xorl %ecx, %ecx
-	movl pt_loc, %ebx
+	xorl %ebx, %ebx
 	
 	floop:
-		movl $((1 << 1) | (1 << 0)), %eax
+		movl $((1 << 7) | (1 << 1) | (1 << 0)), %eax
 		orl %ebx, %eax
 		/* Mapping 0x00000000 + %ecx * 4M => 0x00000000 + %ecx * 4M */
@@ -254,5 +165,5 @@
 		/* Mapping 0x80000000 + %ecx * 4M => 0x00000000 + %ecx * 4M */
 		movl %eax, (%edi, %ecx, 4)
-		addl $(4 * 1024), %ebx
+		addl $(4 * 1024 * 1024), %ebx
 		
 		incl %ecx
@@ -612,11 +523,4 @@
 
 grub_ebx:
-	.long 0
-
-pt_loc:
-	.long 0
-end_of_kernel:
-	.long 0
-free_area:
 	.long 0
 
Index: kernel/arch/ia32/src/cpu/cpu.c
===================================================================
--- kernel/arch/ia32/src/cpu/cpu.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ kernel/arch/ia32/src/cpu/cpu.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -118,11 +118,9 @@
 		);
 	}
-
-#ifndef PROCESSOR_i486
+	
 	if (CPU->arch.fi.bits.sep) {
 		/* Setup fast SYSENTER/SYSEXIT syscalls */
 		syscall_setup_cpu();
 	}
-#endif
 }
 
Index: kernel/arch/ia32/src/proc/scheduler.c
===================================================================
--- kernel/arch/ia32/src/proc/scheduler.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ kernel/arch/ia32/src/proc/scheduler.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -60,10 +60,8 @@
 	uintptr_t kstk = (uintptr_t) &THREAD->kstack[STACK_SIZE];
 	
-#ifndef PROCESSOR_i486
 	if (CPU->arch.fi.bits.sep) {
 		/* Set kernel stack for CP3 -> CPL0 switch via SYSENTER */
 		write_msr(IA32_MSR_SYSENTER_ESP, kstk - sizeof(istate_t));
 	}
-#endif
 	
 	/* Set kernel stack for CPL3 -> CPL0 switch via interrupt */
Index: kernel/arch/ia32/src/syscall.c
===================================================================
--- kernel/arch/ia32/src/syscall.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ kernel/arch/ia32/src/syscall.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -39,5 +39,4 @@
 #include <arch/pm.h>
 
-#ifndef PROCESSOR_i486
 /** Enable & setup support for SYSENTER/SYSEXIT */
 void syscall_setup_cpu(void)
@@ -50,5 +49,4 @@
 	write_msr(IA32_MSR_SYSENTER_EIP, (uint32_t) sysenter_handler);
 }
-#endif
 
 /** @}
Index: kernel/generic/include/console/console.h
===================================================================
--- kernel/generic/include/console/console.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ kernel/generic/include/console/console.h	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -63,5 +63,5 @@
 
 extern void klog_init(void);
-extern void klog_update(void *);
+extern void klog_update(void);
 
 extern wchar_t getc(indev_t *indev);
Index: kernel/generic/include/ipc/event.h
===================================================================
--- kernel/generic/include/ipc/event.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ kernel/generic/include/ipc/event.h	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -41,7 +41,5 @@
 #include <ipc/ipc.h>
 
-struct task;
-
-typedef void (*event_callback_t)(void *);
+typedef void (*event_callback_t)(void);
 
 /** Event notification structure. */
@@ -63,9 +61,6 @@
 
 extern void event_init(void);
-extern void event_task_init(struct task *);
 extern void event_cleanup_answerbox(answerbox_t *);
 extern void event_set_unmask_callback(event_type_t, event_callback_t);
-extern void event_task_set_unmask_callback(struct task *, event_task_type_t,
-    event_callback_t);
 
 #define event_notify_0(e, m) \
@@ -82,21 +77,6 @@
 	event_notify((e), (m), (a1), (a2), (a3), (a4), (a5))
 
-#define event_task_notify_0(t, e, m) \
-	event_task_notify((t), (e), (m), 0, 0, 0, 0, 0)
-#define event_task_notify_1(t, e, m, a1) \
-	event_task_notify((t), (e), (m), (a1), 0, 0, 0, 0)
-#define event_task_notify_2(t, e, m, a1, a2) \
-	event_task_notify((t), (e), (m), (a1), (a2), 0, 0, 0)
-#define event_task_notify_3(t, e, m, a1, a2, a3) \
-	event_task_notify((t), (e), (m), (a1), (a2), (a3), 0, 0)
-#define event_task_notify_4(t, e, m, a1, a2, a3, a4) \
-	event_task_notify((t), (e), (m), (a1), (a2), (a3), (a4), 0)
-#define event_task_notify_5(t, e, m, a1, a2, a3, a4, a5) \
-	event_task_notify((t), (e), (m), (a1), (a2), (a3), (a4), (a5))
-
 extern int event_notify(event_type_t, bool, sysarg_t, sysarg_t, sysarg_t,
     sysarg_t, sysarg_t);
-extern int event_task_notify(struct task *, event_task_type_t, bool, sysarg_t, sysarg_t,
-    sysarg_t, sysarg_t, sysarg_t);
 
 extern sysarg_t sys_event_subscribe(sysarg_t, sysarg_t);
Index: kernel/generic/include/ipc/ipc.h
===================================================================
--- kernel/generic/include/ipc/ipc.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ kernel/generic/include/ipc/ipc.h	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -40,5 +40,4 @@
 #include <synch/mutex.h>
 #include <synch/waitq.h>
-#include <typedefs.h>
 
 #define IPC_MAX_PHONES  32
@@ -99,5 +98,5 @@
 	sysarg_t args[IPC_CALL_LEN];
 	/** Task which made or forwarded the call with IPC_FF_ROUTE_FROM_ME. */
-	task_id_t task_id;
+	struct task *task;
 	/** Phone which made or last masqueraded this call. */
 	phone_t *phone;
Index: kernel/generic/include/proc/task.h
===================================================================
--- kernel/generic/include/proc/task.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ kernel/generic/include/proc/task.h	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -38,6 +38,4 @@
 #include <cpu.h>
 #include <ipc/ipc.h>
-#include <ipc/event.h>
-#include <ipc/kbox.h>
 #include <synch/spinlock.h>
 #include <synch/mutex.h>
@@ -55,4 +53,5 @@
 #include <proc/scheduler.h>
 #include <udebug/udebug.h>
+#include <ipc/kbox.h>
 #include <mm/as.h>
 #include <abi/sysinfo.h>
@@ -94,6 +93,6 @@
 	phone_t phones[IPC_MAX_PHONES];
 	stats_ipc_t ipc_info;   /**< IPC statistics */
-	list_t sync_boxes;      /**< List of synchronous answerboxes. */
-	event_t events[EVENT_TASK_END - EVENT_END];
+	/** List of synchronous answerboxes. */
+	list_t sync_boxes;
 	
 #ifdef CONFIG_UDEBUG
Index: kernel/generic/src/console/console.c
===================================================================
--- kernel/generic/src/console/console.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ kernel/generic/src/console/console.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -248,5 +248,5 @@
 }
 
-void klog_update(void *event)
+void klog_update(void)
 {
 	if (!atomic_get(&klog_inited))
@@ -327,5 +327,5 @@
 	/* Force notification on newline */
 	if (ch == '\n')
-		klog_update(NULL);
+		klog_update();
 }
 
@@ -358,5 +358,5 @@
 		free(data);
 	} else
-		klog_update(NULL);
+		klog_update();
 	
 	return size;
Index: kernel/generic/src/ipc/event.c
===================================================================
--- kernel/generic/src/ipc/event.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ kernel/generic/src/ipc/event.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -40,5 +40,4 @@
 #include <synch/spinlock.h>
 #include <console/console.h>
-#include <proc/task.h>
 #include <memstr.h>
 #include <errno.h>
@@ -48,28 +47,4 @@
 static event_t events[EVENT_END];
 
-static void event_initialize(event_t *event)
-{
-	spinlock_initialize(&event->lock, "event.lock");
-	event->answerbox = NULL;
-	event->counter = 0;
-	event->imethod = 0;
-	event->masked = false;
-	event->unmask_callback = NULL;
-}
-
-static event_t *evno2event(int evno, task_t *t)
-{
-	ASSERT(evno < EVENT_TASK_END);
-
-	event_t *event;
-
-	if (evno < EVENT_END)
-		event = &events[(event_type_t) evno];
-	else
-		event = &t->events[(event_task_type_t) evno - EVENT_END];
-
-	return event;
-}
-
 /** Initialize kernel events.
  *
@@ -77,14 +52,13 @@
 void event_init(void)
 {
-	for (unsigned int i = 0; i < EVENT_END; i++)
-		event_initialize(evno2event(i, NULL));
-}
-
-void event_task_init(task_t *task)
-{
-	for (unsigned int i = EVENT_END; i < EVENT_TASK_END; i++)
-		event_initialize(evno2event(i, task));
-}
-
+	for (unsigned int i = 0; i < EVENT_END; i++) {
+		spinlock_initialize(&events[i].lock, "event.lock");
+		events[i].answerbox = NULL;
+		events[i].counter = 0;
+		events[i].imethod = 0;
+		events[i].masked = false;
+		events[i].unmask_callback = NULL;
+	}
+}
 
 /** Unsubscribe kernel events associated with an answerbox
@@ -109,11 +83,4 @@
 }
 
-static void _event_set_unmask_callback(event_t *event, event_callback_t callback)
-{
-	spinlock_lock(&event->lock);
-	event->unmask_callback = callback;
-	spinlock_unlock(&event->lock);
-}
-
 /** Define a callback function for the event unmask event.
  *
@@ -127,59 +94,7 @@
 	ASSERT(evno < EVENT_END);
 	
-	_event_set_unmask_callback(evno2event(evno, NULL), callback);
-}
-
-void event_task_set_unmask_callback(task_t *task, event_task_type_t evno,
-    event_callback_t callback)
-{
-	ASSERT(evno >= (int) EVENT_END);
-	ASSERT(evno < EVENT_TASK_END);
-		
-	_event_set_unmask_callback(evno2event(evno, task), callback);
-}
-
-static int event_enqueue(event_t *event, bool mask, sysarg_t a1, sysarg_t a2,
-    sysarg_t a3, sysarg_t a4, sysarg_t a5)
-{
-	int res;
-
-	spinlock_lock(&event->lock);
-	
-	if (event->answerbox != NULL) {
-		if (!event->masked) {
-			call_t *call = ipc_call_alloc(FRAME_ATOMIC);
-			
-			if (call) {
-				call->flags |= IPC_CALL_NOTIF;
-				call->priv = ++event->counter;
-				
-				IPC_SET_IMETHOD(call->data, event->imethod);
-				IPC_SET_ARG1(call->data, a1);
-				IPC_SET_ARG2(call->data, a2);
-				IPC_SET_ARG3(call->data, a3);
-				IPC_SET_ARG4(call->data, a4);
-				IPC_SET_ARG5(call->data, a5);
-				
-				call->data.task_id = TASK ? TASK->taskid : 0;
-				
-				irq_spinlock_lock(&event->answerbox->irq_lock, true);
-				list_append(&call->link, &event->answerbox->irq_notifs);
-				irq_spinlock_unlock(&event->answerbox->irq_lock, true);
-				
-				waitq_wakeup(&event->answerbox->wq, WAKEUP_FIRST);
-				
-				if (mask)
-					event->masked = true;
-				
-				res = EOK;
-			} else
-				res = ENOMEM;
-		} else
-			res = EBUSY;
-	} else
-		res = ENOENT;
-	
-	spinlock_unlock(&event->lock);
-	return res;
+	spinlock_lock(&events[evno].lock);
+	events[evno].unmask_callback = callback;
+	spinlock_unlock(&events[evno].lock);
 }
 
@@ -208,34 +123,43 @@
 	ASSERT(evno < EVENT_END);
 	
-	return event_enqueue(evno2event(evno, NULL), mask, a1, a2, a3, a4, a5);
-}
-
-/** Send per-task kernel notification event
- *
- * @param task Destination task.
- * @param evno Event type.
- * @param mask Mask further notifications after a successful
- *             sending.
- * @param a1   First argument.
- * @param a2   Second argument.
- * @param a3   Third argument.
- * @param a4   Fourth argument.
- * @param a5   Fifth argument.
- *
- * @return EOK if notification was successfully sent.
- * @return ENOMEM if the notification IPC message failed to allocate.
- * @return EBUSY if the notifications of the given type are
- *         currently masked.
- * @return ENOENT if the notifications of the given type are
- *         currently not subscribed.
- *
- */
-int event_task_notify(task_t *task, event_task_type_t evno, bool mask,
-    sysarg_t a1, sysarg_t a2, sysarg_t a3, sysarg_t a4, sysarg_t a5)
-{
-	ASSERT(evno >= (int) EVENT_END);
-	ASSERT(evno < EVENT_TASK_END);
-	
-	return event_enqueue(evno2event(evno, task), mask, a1, a2, a3, a4, a5);
+	spinlock_lock(&events[evno].lock);
+	
+	int ret;
+	
+	if (events[evno].answerbox != NULL) {
+		if (!events[evno].masked) {
+			call_t *call = ipc_call_alloc(FRAME_ATOMIC);
+			
+			if (call) {
+				call->flags |= IPC_CALL_NOTIF;
+				call->priv = ++events[evno].counter;
+				
+				IPC_SET_IMETHOD(call->data, events[evno].imethod);
+				IPC_SET_ARG1(call->data, a1);
+				IPC_SET_ARG2(call->data, a2);
+				IPC_SET_ARG3(call->data, a3);
+				IPC_SET_ARG4(call->data, a4);
+				IPC_SET_ARG5(call->data, a5);
+				
+				irq_spinlock_lock(&events[evno].answerbox->irq_lock, true);
+				list_append(&call->link, &events[evno].answerbox->irq_notifs);
+				irq_spinlock_unlock(&events[evno].answerbox->irq_lock, true);
+				
+				waitq_wakeup(&events[evno].answerbox->wq, WAKEUP_FIRST);
+				
+				if (mask)
+					events[evno].masked = true;
+				
+				ret = EOK;
+			} else
+				ret = ENOMEM;
+		} else
+			ret = EBUSY;
+	} else
+		ret = ENOENT;
+	
+	spinlock_unlock(&events[evno].lock);
+	
+	return ret;
 }
 
@@ -252,21 +176,23 @@
  *
  */
-static int event_subscribe(event_t *event, sysarg_t imethod,
+static int event_subscribe(event_type_t evno, sysarg_t imethod,
     answerbox_t *answerbox)
 {
+	ASSERT(evno < EVENT_END);
+	
+	spinlock_lock(&events[evno].lock);
+	
 	int res;
-
-	spinlock_lock(&event->lock);
-	
-	if (event->answerbox == NULL) {
-		event->answerbox = answerbox;
-		event->imethod = imethod;
-		event->counter = 0;
-		event->masked = false;
+	
+	if (events[evno].answerbox == NULL) {
+		events[evno].answerbox = answerbox;
+		events[evno].imethod = imethod;
+		events[evno].counter = 0;
+		events[evno].masked = false;
 		res = EOK;
 	} else
 		res = EEXISTS;
 	
-	spinlock_unlock(&event->lock);
+	spinlock_unlock(&events[evno].lock);
 	
 	return res;
@@ -278,10 +204,12 @@
  *
  */
-static void event_unmask(event_t *event)
-{
-	spinlock_lock(&event->lock);
-	event->masked = false;
-	event_callback_t callback = event->unmask_callback;
-	spinlock_unlock(&event->lock);
+static void event_unmask(event_type_t evno)
+{
+	ASSERT(evno < EVENT_END);
+	
+	spinlock_lock(&events[evno].lock);
+	events[evno].masked = false;
+	event_callback_t callback = events[evno].unmask_callback;
+	spinlock_unlock(&events[evno].lock);
 	
 	/*
@@ -290,5 +218,5 @@
 	 */
 	if (callback != NULL)
-		callback(event);
+		callback();
 }
 
@@ -307,9 +235,9 @@
 sysarg_t sys_event_subscribe(sysarg_t evno, sysarg_t imethod)
 {
-	if (evno >= EVENT_TASK_END)
+	if (evno >= EVENT_END)
 		return ELIMIT;
 	
-	return (sysarg_t) event_subscribe(evno2event(evno, TASK),
-	    (sysarg_t) imethod, &TASK->answerbox);
+	return (sysarg_t) event_subscribe((event_type_t) evno, (sysarg_t)
+	    imethod, &TASK->answerbox);
 }
 
@@ -329,9 +257,8 @@
 sysarg_t sys_event_unmask(sysarg_t evno)
 {
-	if (evno >= EVENT_TASK_END)
+	if (evno >= EVENT_END)
 		return ELIMIT;
 	
-	event_unmask(evno2event(evno, TASK));
-
+	event_unmask((event_type_t) evno);
 	return EOK;
 }
Index: kernel/generic/src/ipc/ipc.c
===================================================================
--- kernel/generic/src/ipc/ipc.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ kernel/generic/src/ipc/ipc.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -294,5 +294,5 @@
 		atomic_inc(&phone->active_calls);
 		call->data.phone = phone;
-		call->data.task_id = TASK->taskid;
+		call->data.task = TASK;
 	}
 	
@@ -406,5 +406,5 @@
 			call->caller_phone = call->data.phone;
 		call->data.phone = newphone;
-		call->data.task_id = TASK->taskid;
+		call->data.task = TASK;
 	}
 	
Index: kernel/generic/src/ipc/sysipc.c
===================================================================
--- kernel/generic/src/ipc/sysipc.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ kernel/generic/src/ipc/sysipc.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -44,5 +44,4 @@
 #include <ipc/irq.h>
 #include <ipc/ipcrsc.h>
-#include <ipc/event.h>
 #include <ipc/kbox.h>
 #include <synch/waitq.h>
@@ -54,5 +53,4 @@
 #include <mm/as.h>
 #include <print.h>
-#include <macros.h>
 
 /**
@@ -136,5 +134,4 @@
 	case IPC_M_DATA_WRITE:
 	case IPC_M_DATA_READ:
-	case IPC_M_STATE_CHANGE_AUTHORIZE:
 		return true;
 	default:
@@ -167,5 +164,4 @@
 	case IPC_M_DATA_WRITE:
 	case IPC_M_DATA_READ:
-	case IPC_M_STATE_CHANGE_AUTHORIZE:
 		return true;
 	default:
@@ -253,7 +249,6 @@
 			/* The connection was accepted */
 			phone_connect(phoneid, &answer->sender->answerbox);
-			/* Set 'task ID' as arg3 and arg4 of response */
-			IPC_SET_ARG3(answer->data, LOWER32(TASK->taskid));
-			IPC_SET_ARG4(answer->data, UPPER32(TASK->taskid));
+			/* Set 'task hash' as arg4 of response */
+			IPC_SET_ARG4(answer->data, (sysarg_t) TASK);
 			/* Set 'phone hash' as arg5 of response */
 			IPC_SET_ARG5(answer->data,
@@ -339,50 +334,4 @@
 		free(answer->buffer);
 		answer->buffer = NULL;
-	} else if (IPC_GET_IMETHOD(*olddata) == IPC_M_STATE_CHANGE_AUTHORIZE) {
-		if (!IPC_GET_RETVAL(answer->data)) {
-			/* The recipient authorized the change of state. */
-			phone_t *recipient_phone;
-			task_t *other_task_s;
-			task_t *other_task_r;
-			int rc;
-
-			rc = phone_get(IPC_GET_ARG1(answer->data),
-			    &recipient_phone);
-			if (rc != EOK) {
-				IPC_SET_RETVAL(answer->data, ENOENT);
-				return ENOENT;
-			}
-
-			mutex_lock(&recipient_phone->lock);
-			if (recipient_phone->state != IPC_PHONE_CONNECTED) {
-				mutex_unlock(&recipient_phone->lock);
-				IPC_SET_RETVAL(answer->data, EINVAL);
-				return EINVAL;
-			}
-
-			other_task_r = recipient_phone->callee->task;
-			other_task_s = (task_t *) IPC_GET_ARG5(*olddata);
-
-			/*
-			 * See if both the sender and the recipient meant the
-			 * same third party task.
-			 */
-			if (other_task_r != other_task_s) {
-				IPC_SET_RETVAL(answer->data, EINVAL);
-				rc = EINVAL;
-			} else {
-				rc = event_task_notify_5(other_task_r,
-				    EVENT_TASK_STATE_CHANGE, false,
-				    IPC_GET_ARG1(*olddata),
-				    IPC_GET_ARG2(*olddata),
-				    IPC_GET_ARG3(*olddata),
-				    LOWER32(olddata->task_id),
-				    UPPER32(olddata->task_id));
-				IPC_SET_RETVAL(answer->data, rc);
-			}
-
-			mutex_unlock(&recipient_phone->lock);
-			return rc;
-		}
 	}
 	
@@ -507,25 +456,4 @@
 		}
 		
-		break;
-	}
-	case IPC_M_STATE_CHANGE_AUTHORIZE: {
-		phone_t *sender_phone;
-		task_t *other_task_s;
-
-		if (phone_get(IPC_GET_ARG5(call->data), &sender_phone) != EOK)
-			return ENOENT;
-
-		mutex_lock(&sender_phone->lock);
-		if (sender_phone->state != IPC_PHONE_CONNECTED) {
-			mutex_unlock(&sender_phone->lock);
-			return EINVAL;
-		}
-
-		other_task_s = sender_phone->callee->task;
-
-		mutex_unlock(&sender_phone->lock);
-
-		/* Remember the third party task hash. */
-		IPC_SET_ARG5(call->data, (sysarg_t) other_task_s);
 		break;
 	}
Index: kernel/generic/src/proc/task.c
===================================================================
--- kernel/generic/src/proc/task.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ kernel/generic/src/proc/task.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -50,5 +50,4 @@
 #include <ipc/ipc.h>
 #include <ipc/ipcrsc.h>
-#include <ipc/event.h>
 #include <print.h>
 #include <errno.h>
@@ -58,4 +57,5 @@
 #include <syscall/copy.h>
 #include <macros.h>
+#include <ipc/event.h>
 
 /** Spinlock protecting the tasks_tree AVL tree. */
@@ -201,6 +201,4 @@
 	task->ipc_info.irq_notif_received = 0;
 	task->ipc_info.forwarded = 0;
-
-	event_task_init(task);
 	
 #ifdef CONFIG_UDEBUG
Index: uspace/Makefile
===================================================================
--- uspace/Makefile	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/Makefile	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -37,5 +37,4 @@
 	app/blkdump \
 	app/bnchmark \
-	app/devctl \
 	app/edit \
 	app/ext2info \
Index: uspace/app/bdsh/exec.c
===================================================================
--- uspace/app/bdsh/exec.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/app/bdsh/exec.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -40,5 +40,4 @@
 #include <str_error.h>
 #include <errno.h>
-#include <vfs/vfs.h>
 
 #include "config.h"
@@ -100,6 +99,6 @@
 	char *tmp;
 	int rc, retval, i;
-	int file_handles[3];
-	int *file_handles_p[4];
+	fdi_node_t file_nodes[3];
+	fdi_node_t *file_nodes_p[4];
 	FILE *files[3];
 
@@ -112,14 +111,14 @@
 	
 	for (i = 0; i < 3 && files[i] != NULL; i++) {
-		if (fhandle(files[i], &file_handles[i]) == EOK) {
-			file_handles_p[i] = &file_handles[i];
+		if (fnode(files[i], &file_nodes[i]) == EOK) {
+			file_nodes_p[i] = &file_nodes[i];
 		}
 		else {
-			file_handles_p[i] = NULL;
+			file_nodes_p[i] = NULL;
 		}
 	}
-	file_handles_p[i] = NULL;
+	file_nodes_p[i] = NULL;
 
-	rc = task_spawnvf(&tid, tmp, (const char **) argv, file_handles_p);
+	rc = task_spawnvf(&tid, tmp, (const char **) argv, file_nodes_p);
 	free(tmp);
 
Index: uspace/app/lsusb/main.c
===================================================================
--- uspace/app/lsusb/main.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/app/lsusb/main.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -81,5 +81,5 @@
 		}
 		char path[MAX_PATH_LENGTH];
-		rc = devman_fun_get_path(dev_handle, path, MAX_PATH_LENGTH);
+		rc = devman_get_device_path(dev_handle, path, MAX_PATH_LENGTH);
 		if (rc != EOK) {
 			continue;
@@ -120,5 +120,5 @@
 		}
 		char path[MAX_PATH_LENGTH];
-		rc = devman_fun_get_path(hc_handle, path, MAX_PATH_LENGTH);
+		rc = devman_get_device_path(hc_handle, path, MAX_PATH_LENGTH);
 		if (rc != EOK) {
 			printf(NAME ": Error resolving path of HC with SID %"
Index: uspace/app/mkbd/main.c
===================================================================
--- uspace/app/mkbd/main.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/app/mkbd/main.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -240,5 +240,5 @@
 	
 	char path[MAX_PATH_LENGTH];
-	rc = devman_fun_get_path(dev_handle, path, MAX_PATH_LENGTH);
+	rc = devman_get_device_path(dev_handle, path, MAX_PATH_LENGTH);
 	if (rc != EOK) {
 		return ENOMEM;
Index: uspace/app/tester/hw/serial/serial1.c
===================================================================
--- uspace/app/tester/hw/serial/serial1.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/app/tester/hw/serial/serial1.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -72,5 +72,5 @@
 	
 	devman_handle_t handle;
-	int res = devman_fun_get_handle("/hw/pci0/00:01.0/com1/a", &handle,
+	int res = devman_device_get_handle("/hw/pci0/00:01.0/com1/a", &handle,
 	    IPC_FLAG_BLOCKING);
 	if (res != EOK)
Index: uspace/app/trace/trace.c
===================================================================
--- uspace/app/trace/trace.c	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/app/trace/trace.c	(revision cf22adae6847bfd38cc71105b2e33cf57afaf326)
@@ -50,5 +50,4 @@
 #include <sys/types.h>
 #include <sys/typefmt.h>
-#include <vfs/vfs.h>
 
 #include <libc.h>
@@ -587,21 +586,21 @@
 
 	/* Send default files */
-	int *files[4];
-	int fd_stdin;
-	int fd_stdout;
-	int fd_stderr;
-	
-	if ((stdin != NULL) && (fhandle(stdin, &fd_stdin) == EOK))
-		files[0] = &fd_stdin;
+	fdi_node_t *files[4];
+	fdi_node_t stdin_node;
+	fdi_node_t stdout_node;
+	fdi_node_t stderr_node;
+	
+	if ((stdin != NULL) && (fnode(stdin, &stdin_node) == EOK))
+		files[0] = &stdin_node;
 	else
 		files[0] = NULL;
 	
-	if ((stdout != NULL) && (fhandle(stdout, &fd_stdout) == EOK))
-		files[1] = &fd_stdout;
+	if ((stdout != NULL) && (fnode(stdout, &stdout_node) == EOK))
+		files[1] = &stdout_node;
 	else
 		files[1] = NULL;
 	
-	if ((stderr != NULL) && (fhandle(stderr, &fd_stderr) == EOK))
-		files[2] = &fd_stderr;
+	if ((stderr != NULL) && (fnode(stderr, &stderr_node) == EOK))
+		files[2] = &stderr_node;
 	else
 		files[2] = NULL;
@@ -762,4 +761,6 @@
 	o = oper_new("open", 2, arg_def, V_INT_ERRNO, 0, resp_def);
 	proto_add_oper(p, VFS_IN_OPEN, o);
+	o = oper_new("open_node", 4, arg_def, V_INT_ERRNO, 0, resp_def);
+	proto_add_oper(p, VFS_IN_OPEN_NODE, o);
 	o = oper_new("read", 1, arg_def, V_ERRNO, 1, resp_def);
 	proto_add_oper(p, VFS_IN_READ, o);
